;********************************************************************************
;*** rcupration des valeurs issues de la balise
;********************************************************************************

Mode_Detection_Balise

	bsf	PORTB,4	;DDDDDDEEEEEEEEEEEBBBBBBBUUUUUUGGGGGGGG!!!!!!!!!!!!!!!!

	Call communication_OK

	BSF STATUS,RP0
	BCF STATUS,RP0

INIT
	CLRF TIMELOW
	CLRF TIMEHIGH

BOUCLEINIT          ;attendre que RA4 soit au niveau haut.
	BTFSS PORTA,4
	GOTO BOUCLEINIT

BOUCLEEDGE          ;attendre un front descendant.
	BTFSC PORTA,4
	GOTO BOUCLEEDGE

COMPTAGELOW         ;mesurer le temps au niveaut bas.
	CALL TEMPO
	INCF TIMELOW,F
	BTFSS PORTA,4
	GOTO COMPTAGELOW

COMPTAGEHIGH        ;mesurer le temps au niveaut haut.
	CALL TEMPO_HIGH
	INCF TIMEHIGH,F
	Movlw	0X0FA
	SUBWF	TIMEHIGH,W
	BTFSC	STATUS,C
	GOTO	WRONG
	BTFSC PORTA,4
	GOTO COMPTAGEHIGH

TEST    ;verifier que temps haut + temps bas n' est a peu
	MOVF TIMEHIGH, W    ;pres egal a la periode du signal des balises.
	ADDWF TIMELOW,W
	BCF STATUS,C
	SUBLW 0X0FD

	BTFSS STATUS, C
	Call WRONG_VALEUR

	BTFSC STATUS, C		;Test temps total < FD
	Call GOOD

	bcf	PORTB,4	;DDDDDDEEEEEEEEEEEBBBBBBBUUUUUUGGGGGGGG!!!!!!!!!!!!!!!!
	return

GOOD                    ;si c' est bon metre le numerot de balise sur le

	BCF STATUS,C
	SUBLW 0X02F
	BTFSC STATUS, C		;Test temps total < 2F
	Call WRONG_VALEUR

	BTFSC STATUS, C		;Test temps total < 2F
	GOTO FIN_GOOD

	bsf	PORTB,4	;!!! pour debug!!!

	BCF STATUS,C
	RRF TIMELOW, W         	;division par 2.
	Call ENVOI_PICBASIC	;Envoi N au PICBASIC via liaison srie

FIN_GOOD
	BCF STATUS,C
	RETURN

WRONG_VALEUR
	MOVLW 0X000
	Call ENVOI_PICBASIC	;Envoi FAUX (0) via liaison srie

	return

WRONG                  
	Goto INIT
	
TEMPO                   ;Tempo de 104 micro secondes.
	MOVLW 0X018
	MOVWF COMPTEUR

BOUCLETEMPO
	NOP
	DECFSZ COMPTEUR, F
	GOTO BOUCLETEMPO
	NOP
	RETURN

TEMPO_HIGH
	MOVLW 0X017
	MOVWF COMPTEUR

BOUCLETEMPO_HIGH
	NOP
	DECFSZ COMPTEUR, F
	GOTO BOUCLETEMPO_HIGH
	NOP
	NOP
	RETURN
