;******************************************
;*** Envoie les infos au PICBASIC Via I2C
;******************************************


ENVOI_PICBASIC	
	movwf	venv
	;*******************************
	;*** Clock sur le port B7    ***
	;*** Data sur le port B6     ***
	;*******************************

	;***********************************************
	;*** Envoi du signal pret au picbasic et attente
	;***********************************************
	bsf	PORTB,6

DEB_ENVOI
	bsf PORTB,6
	btfss PORTB,7
	GOTO DEB_ENVOI

	bcf	PORTB,6
	
	;***********************************************
	;*** Envoi des donnes au PICBASIC
	;***********************************************	
	btfsc venv,0
	call ENVOI_1_PICBASIC

	btfss venv,0
	call ENVOI_0_PICBASIC
	
	btfsc venv,1
	call ENVOI_1_PICBASIC

	btfss venv,1
	call ENVOI_0_PICBASIC

	btfsc venv,2
	call ENVOI_1_PICBASIC

	btfss venv,2
	call ENVOI_0_PICBASIC

	btfsc venv,3
	call ENVOI_1_PICBASIC
	
	btfss venv,3	
	call ENVOI_0_PICBASIC

	btfsc venv,4
	call ENVOI_1_PICBASIC
	
	btfss venv,4	
	call ENVOI_0_PICBASIC

	btfsc venv,5
	call ENVOI_1_PICBASIC
	
	btfss venv,5	
	call ENVOI_0_PICBASIC

	btfsc venv,6
	call ENVOI_1_PICBASIC
	
	btfss venv,6	
	call ENVOI_0_PICBASIC

	btfsc venv,7
	call ENVOI_1_PICBASIC
	
	btfss venv,7	
	call ENVOI_0_PICBASIC

	bcf PORTB,6	

	RETURN	
	
ENVOI_1_PICBASIC
	bcf PORTB,6
deb_ENVOI_1_PICBASIC
	btfss PORTB,7
	goto deb_ENVOI_1_PICBASIC

	bsf	PORTB,6
bcle_ENVOI_1_PICBASIC	
	btfsc PORTB,7
	goto bcle_ENVOI_1_PICBASIC	
	bcf PORTB,6
	RETURN	
	
ENVOI_0_PICBASIC
	bcf	PORTB,6

deb_ENVOI_0_PICBASIC
	btfss PORTB,7
	goto deb_ENVOI_0_PICBASIC
bcle_ENVOI_0_PICBASIC	
	btfsc PORTB,7
	goto bcle_ENVOI_0_PICBASIC	
	RETURN		
