;************************************************************************************************
;*** Fonction initIO pour initialiser les ports d'E/S du pic	                              ***
;*************************************************************************************************

INITIO
	clrf    PORTA           ;*** init port A
        bsf	STATUS,RP0
        movlw   B'00011111'	;*** PORT A : tous en entre
	movwf   TRISA
        bcf 	STATUS,RP0
        clrf    PORTB           ;*** init port B
        bsf 	STATUS,RP0
        movlw   B'10001111' 	;*** port B : sortie/entres
        movwf   TRISB
        bcf 	STATUS,RP0

	;*** pas de gestion d'interruptions actuellement
	bsf	STATUS,RP0
	movlw   0x000
	movwf   INTCON
	bcf	STATUS,RP0

	return

