;**********************************************
;*** Rception d'infos issue s du picbasic
;*** infos envoyes par le PICBASIC sur le port RA0 (port du picbasic)
;*** signal de clock sur port RAB7 (port du picbasic)
;**********************************************

reception_infos_picbasic

	clrf	vrec
	bcf	PORTB,4	;DEBUG !!!!!!!!!!!

attente_capt1
	btfss	PORTB,7
	goto	attente_capt1

	bsf	PORTB,4	;DEBUG !!!!!!!!!!!

	;*** bit 0
bit0
	btfsc	PORTB,7
	call	recup_capt1_bit0
	btfsc	PORTB,7
	goto	bit0

rcv0
	btfss	PORTB,7
	goto	rcv0

	;*** bit 1
bit1
	btfsc	PORTB,7
	call	recup_capt1_bit1
	btfsc	PORTB,7
	goto	bit1

rcv1
	btfss	PORTB,7
	goto	rcv1

	;*** bit 2
bit2
	btfsc	PORTB,7
	call	recup_capt1_bit2
	btfsc	PORTB,7
	goto	bit2

rcv2
	btfss	PORTB,7
	goto	rcv2

	;*** bit 3
bit3
	btfsc	PORTB,7
	call	recup_capt1_bit3
	btfsc	PORTB,7
	goto	bit3

rcv3
	btfss	PORTB,7
	goto	rcv3

	;*** bit 4
bit4
	btfsc	PORTB,7
	call	recup_capt1_bit4
	btfsc	PORTB,7
	goto	bit4

rcv4
	btfss	PORTB,7
	goto	rcv4

	;*** bit 5
bit5
	btfsc	PORTB,7
	call	recup_capt1_bit5
	btfsc	PORTB,7
	goto	bit5

rcv5
	btfss	PORTB,7
	goto	rcv5

	;*** bit 6
bit6
	btfsc	PORTB,7
	call	recup_capt1_bit6
	btfsc	PORTB,7
	goto	bit6

rcv6
	btfss	PORTB,7
	goto	rcv6

	;*** bit 7
bit7
	btfsc	PORTB,7
	call	recup_capt1_bit7
	btfsc	PORTB,7
	goto	bit7

	;*** Rsultat de la rception 
	movf	vrec,W

	bcf	PORTB,4	;DEBUG !!!!!!!!!!!

	return

recup_capt1_bit0
	btfsc	PORTA,0
	bsf	vrec,0
	btfss	PORTA,0
	bcf	vrec,0
	return

recup_capt1_bit1
	btfsc	PORTA,0
	bsf	vrec,1
	btfss	PORTA,0
	bcf	vrec,1
	return

recup_capt1_bit2
	btfsc	PORTA,0
	bsf	vrec,2
	btfss	PORTA,0
	bcf	vrec,2
	return

recup_capt1_bit3
	btfsc	PORTA,0
	bsf	vrec,3
	btfss	PORTA,0
	bcf	vrec,3
	return

recup_capt1_bit4
	btfsc	PORTA,0
	bsf	vrec,4
	btfss	PORTA,0
	bcf	vrec,4
	return

recup_capt1_bit5
	btfsc	PORTA,0
	bsf	vrec,5
	btfss	PORTA,0
	bcf	vrec,5
	return

recup_capt1_bit6
	btfsc	PORTA,0
	bsf	vrec,6
	btfss	PORTA,0
	bcf	vrec,6
	return

recup_capt1_bit7
	btfsc	PORTA,0
	bsf	vrec,7
	btfss	PORTA,0
	bcf	vrec,7
	return
